package inheritance.override;

/**
 *
 * @author hajo
 */
public class TestTypeCompatibility {

    // Throws InterruptedException because of sleep() below
    public static void main(String args[]) throws InterruptedException {
        Base b1 = new Base();
        Base b2 = new Sub();
        Sub s1 = new Sub();

        // Get runtime type
        System.out.println(b1.getClass());
        System.out.println(b2.getClass());
        System.out.println(s1.getClass());

        // Check typecompatibility
        System.out.println(b1 instanceof Base);
        System.out.println(b1 instanceof Sub);
        System.out.println(b2 instanceof Base);
        System.out.println(b2 instanceof Sub);
        System.out.println(s1 instanceof Base);
        System.out.println(s1 instanceof Sub);
        System.out.println(null instanceof Base);
        System.out.println(null instanceof Sub);

        Base b3 = s1;
        //s1 = b3;   // Compile error
        Sub s2 = (Sub) b3;  // Ok
        
        Thread.sleep(1000); // Stop for one second (so we don't mix output)
        
        s2 = (Sub) b1; // ClassCastException
        System.out.println(s2.getValue());
    }
}
