/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mvc;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * The view
 * @author hajo
 */
public class View extends JPanel implements ActionListener, EventBus.IEventHandler {

    private final JTextField in = new JTextField(10);
    private final JLabel out = new JLabel("unset");
    private final Model model;

    public View(Model model) {
        this.model = model;
        in.addActionListener(this);
        EventBus.INSTANCE.register(this);
        add(new JLabel("Enter and hit return"));
        add(in);
        add(out);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        System.out.println("Listener got event from textfield");
        JTextField i = (JTextField) e.getSource();
        String s = i.getText();
        model.doIt(s);
    }

    @Override
    public void onEvent(EventBus.Event evt, Object o) {
        System.out.println("Listener got event and data from model");
        if( evt == EventBus.Event.NEW_DATA){
            String s = (String) o;
            out.setText(s);
        }
    }
}
